import 'package:analyzer/dart/analysis/analysis_context_collection.dart';
import 'package:analyzer/dart/analysis/results.dart';
import 'package:analyzer/file_system/physical_file_system.dart';
import 'package:cat_analyzer_plugin/rules/avoid_hard_coded_string_rule.dart';

int calculate() {
  return 6 * 7;
}

void analyzeFile(String filePath) async {
  final normalizedFilePath = Uri(path: filePath).normalizePath().path;
  final analysisContextCollection = AnalysisContextCollection(
    includedPaths: [normalizedFilePath],
    excludedPaths: [],
    resourceProvider: PhysicalResourceProvider.INSTANCE,
  );
  final result = await analysisContextCollection
      .contextFor(normalizedFilePath)
      .currentSession
      .getResolvedUnit2(normalizedFilePath) as ResolvedUnitResult;


  final unit = result.unit;
  final content = result.content;
  if (unit == null || content == null || result.state != ResultState.VALID) {
    return;
  }

  final hardCodedStringRule = AvoidHardCodedStringRule('hardCodedString');
  var issues = hardCodedStringRule.check(result);

  // print(result.content ?? '');
}
