import 'package:cat_analyzer_plugin/rules/avoid_hard_coded_url_rule.dart';
import 'package:cat_analyzer_plugin/rules/avoid_hard_coded_string_rule.dart';

import '../model/rule.dart';

Map<String, Rule> registeredRulesMap = {
  'avoid-hard-coded-string': AvoidHardCodedStringRule('avoid-hard-coded-string'),
  'avoid-hard-coded-url': AvoidHardCodedUrlRule('avoid-hard-coded-url'),
  // 'prefer-double-quotes': PreferDoubleQuotesRule('prefer-double-quotes'),
};

Rule? findRuleById(String ruleId) {
  return registeredRulesMap[ruleId];
}

List<Rule?> getRulesById(List<String> rulesId) {
  return rulesId.map((id) => registeredRulesMap[id]).toList();
}

List<Rule> getAllRules() {
  return registeredRulesMap.values.toList();
}

