import 'package:analyzer/dart/analysis/results.dart';
import 'package:analyzer_plugin/protocol/protocol_common.dart';
import 'package:cat_analyzer_plugin/model/error_issue.dart';

// class HardCodedStringFixContributor extends Object
//     with FixContributorMixin
//     implements FixContributor {
//   static FixKind defineComponent =
//       FixKind('hardCodedString', 0, 'save string in local_language.json');
//
//   AnalysisSession? get session => request?.result.session;
//
//   @override
//   Future<void> computeFixes(DartFixesRequest request, FixCollector collector) async {
//     for (var error in request.errorsToFix) {
//       await computeFixesForError(error);
//     }
//   }
//
//   @override
//   Future<void> computeFixesForError(AnalysisError error) async {}
// }

// abstract class CatSourceChange {
//   SourceChange buildChange(ResolvedUnitResult analysisResult);
// }
SourceChange findSourceChange(ResolvedUnitResult analysisResult, Issue issue) {
  // switch (issue.code) {
  //   case 'avoid-using-hard-coded-string':
  //     return hardCodedStringFixSourceChange(analysisResult, issue);
  //   case 'prefer-double-quotes':
  //     return hardCodedStringFixSourceChange(analysisResult, issue);
  // }
  return SourceChange(issue.comment!);
}

SourceChange hardCodedStringFixSourceChange(
    ResolvedUnitResult analysisResult, Issue issue) {
  // var changeBuilder = ChangeBuilder(session: analysisResult.session);
  // await changeBuilder.addDartFileEdit(analysisResult.path ?? '',
  //     (DartFileEditBuilder fileEditBuilder) {
  //   fileEditBuilder.addReplacement(SourceRange(issue.offset!, issue.length!), (DartEditBuilder editBuilder) {
  //     var originalContent = analysisResult.content?.substring(issue.offset!, issue.length!);
  //
  //   });
  // });
  //
  // return changeBuilder.sourceChange;
  var originalContent =
      analysisResult.content?.substring(issue.offset!, issue.offset! + issue.length!);
  var replacement =
      '\"${originalContent?.substring(1, originalContent.length - 1)}\"';
  return SourceChange(
    issue.comment ?? '',
    edits: [
      SourceFileEdit(
        analysisResult.libraryElement.source.fullName,
        analysisResult.libraryElement.source.modificationStamp,
        edits: [
          SourceEdit(
            issue.offset!,
            issue.length!,
            replacement,
          ),
        ],
      ),
    ],
    selection: Position(analysisResult.libraryElement.source.fullName,
        issue.offset! + issue.length!),
  );
}
